/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.39 from the
 * contents of Interrupt.xs. Do not edit this file, edit Interrupt.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "Interrupt.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#define ECB_NO_LIBM 1
#define ECB_NO_THREADS 1
#include "ecb.h"
#include "schmorp.h"

typedef volatile sig_atomic_t atomic_t;

static int *sig_pending, *psig_pend; /* make local copies because of missing THX */
static Sighandler_t old_sighandler;
static atomic_t async_pending;

#define PERL_VERSION_ATLEAST(a,b,c)                             \
  (PERL_REVISION > (a)                                          \
   || (PERL_REVISION == (a)                                     \
       && (PERL_VERSION > (b)                                   \
           || (PERL_VERSION == (b) && PERL_SUBVERSION >= (c)))))

#if defined(HAS_SIGACTION) && defined(SA_SIGINFO)
# define HAS_SA_SIGINFO 1
#endif

#if !PERL_VERSION_ATLEAST(5,10,0)
# undef HAS_SA_SIGINFO
#endif

/*****************************************************************************/

typedef struct {
  SV *cb;
  void (*c_cb)(pTHX_ void *c_arg, int value);
  void *c_arg;
  SV *fh_r, *fh_w;
  SV *value;
  int signum;
  int autodrain;
  ANY *scope_savestack;
  volatile int blocked;

  s_epipe ep;
  int fd_wlen;
  atomic_t fd_enable;
  atomic_t pending;
  volatile IV *valuep;
  atomic_t hysteresis;
} async_t;

static AV *asyncs;
static async_t *sig_async [SIG_SIZE];

#define SvASYNC_nrv(sv) INT2PTR (async_t *, SvIVX (sv))
#define SvASYNC(rv)     SvASYNC_nrv (SvRV (rv))

static void async_signal (void *signal_arg, int value);

static void
setsig (int signum, void (*handler)(int))
{
#if _WIN32
  signal (signum, handler);
#else
  struct sigaction sa;
  sa.sa_handler = handler;
  sigfillset (&sa.sa_mask);
  sa.sa_flags = 0; /* if we interrupt a syscall, we might drain the pipe before it became ready */
  sigaction (signum, &sa, 0);
#endif
}

static void
async_sigsend (int signum)
{
  async_signal (sig_async [signum], 0);
}

/* the main workhorse to signal */
static void
async_signal (void *signal_arg, int value)
{
  static char pipedata [8];

  async_t *async = (async_t *)signal_arg;
  int pending = async->pending;

  if (async->hysteresis)
    setsig (async->signum, SIG_IGN);

  *async->valuep = value ? value : 1;
  ECB_MEMORY_FENCE_RELEASE;
  async->pending = 1;
  ECB_MEMORY_FENCE_RELEASE;
  async_pending  = 1;
  ECB_MEMORY_FENCE_RELEASE;

  if (!async->blocked)
    {
      psig_pend [9]  = 1;
      ECB_MEMORY_FENCE_RELEASE;
      *sig_pending   = 1;
      ECB_MEMORY_FENCE_RELEASE;
    }

  if (!pending && async->fd_enable && async->ep.len)
    s_epipe_signal (&async->ep);
}

static void
handle_async (async_t *async)
{
  int old_errno = errno;
  int value = *async->valuep;

  *async->valuep = 0;
  async->pending = 0;

  /* restore signal */
  if (async->hysteresis)
    setsig (async->signum, async_sigsend);

  /* drain pipe */
  if (async->fd_enable && async->ep.len && async->autodrain)
    s_epipe_drain (&async->ep);

  if (async->c_cb)
    {
      dTHX;
      async->c_cb (aTHX_ async->c_arg, value);
    }

  if (async->cb)
    {
      dSP;

      SV *saveerr = SvOK (ERRSV) ? sv_mortalcopy (ERRSV) : 0;
      SV *savedie = PL_diehook;

      PL_diehook = 0;

      PUSHSTACKi (PERLSI_SIGNAL);

      PUSHMARK (SP);
      XPUSHs (sv_2mortal (newSViv (value)));
      PUTBACK;
      call_sv (async->cb, G_VOID | G_DISCARD | G_EVAL);

      if (SvTRUE (ERRSV))
        {
          SPAGAIN;

          PUSHMARK (SP);
          PUTBACK;
          call_sv (get_sv ("Async::Interrupt::DIED", 1), G_VOID | G_DISCARD | G_EVAL | G_KEEPERR);

          sv_setpvn (ERRSV, "", 0);
        }

      if (saveerr)
        sv_setsv (ERRSV, saveerr);

      {
        SV *oldhook = PL_diehook;
        PL_diehook = savedie;
        SvREFCNT_dec (oldhook);
      }

      POPSTACK;
    }

  errno = old_errno;
}

static void
handle_asyncs (void)
{
  int i;

  ECB_MEMORY_FENCE_ACQUIRE;

  async_pending = 0;

  for (i = AvFILLp (asyncs); i >= 0; --i)
    {
      SV *async_sv = AvARRAY (asyncs)[i];
      async_t *async = SvASYNC_nrv (async_sv);

      if (async->pending && !async->blocked)
        {
          /* temporarily keep a refcount */
          SvREFCNT_inc (async_sv);
          handle_async (async);
          SvREFCNT_dec (async_sv);

          /* the handler could have deleted any number of asyncs */
          if (i > AvFILLp (asyncs))
            i = AvFILLp (asyncs);
        }
    }
}

#if HAS_SA_SIGINFO
static Signal_t async_sighandler (int signum, siginfo_t *si, void *sarg)
{
  if (signum == 9)
    handle_asyncs ();
  else
    old_sighandler (signum, si, sarg);
}
#else
static Signal_t async_sighandler (int signum)
{
  if (signum == 9)
    handle_asyncs ();
  else
    old_sighandler (signum);
}
#endif

#define block(async) ++(async)->blocked

static void
unblock (async_t *async)
{
  --async->blocked;
  if (async->pending && !async->blocked)
    handle_async (async);
}

static void
scope_block_cb (pTHX_ void *async_sv)
{
  async_t *async = SvASYNC_nrv ((SV *)async_sv);

  async->scope_savestack = 0;
  unblock (async);
  SvREFCNT_dec (async_sv);
}

static void
scope_block (SV *async_sv)
{
  async_t *async = SvASYNC_nrv (async_sv);

  /* as a heuristic, we skip the scope block if we already are blocked */
  /* and the existing scope block used the same savestack */

  if (!async->scope_savestack || async->scope_savestack != PL_savestack)
    {
      async->scope_savestack = PL_savestack;
      block (async);

      LEAVE; /* unfortunately, perl sandwiches XS calls into ENTER/LEAVE */
      SAVEDESTRUCTOR_X (scope_block_cb, (void *)SvREFCNT_inc (async_sv));
      ENTER; /* unfortunately, perl sandwiches XS calls into ENTER/LEAVE */
    }
}

#line 270 "Interrupt.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 414 "Interrupt.c"

XS_EUPXS(XS_Async__Interrupt__alloc); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Async__Interrupt__alloc)
{
    dVAR; dXSARGS;
    if (items != 7)
       croak_xs_usage(cv,  "cb, c_cb, c_arg, fh_r, fh_w, signl, pvalue");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	cb = ST(0)
;
	void *	c_cb = INT2PTR(void *,SvIV(ST(1)))
;
	void *	c_arg = INT2PTR(void *,SvIV(ST(2)))
;
	SV *	fh_r = ST(3)
;
	SV *	fh_w = ST(4)
;
	SV *	signl = ST(5)
;
	SV *	pvalue = ST(6)
;
#line 275 "Interrupt.xs"
{
        SV *cv   = SvOK (cb) ? SvREFCNT_inc (s_get_cv_croak (cb)) : 0;
	async_t *async;

        Newz (0, async, 1, async_t);

        XPUSHs (sv_2mortal (newSViv (PTR2IV (async))));
        /* TODO: need to bless right now to ensure deallocation */
        av_push (asyncs, TOPs);

        SvGETMAGIC (fh_r); SvGETMAGIC (fh_w);
        if (SvOK (fh_r) || SvOK (fh_w))
          {
            int fd_r = s_fileno_croak (fh_r, 0);
            int fd_w = s_fileno_croak (fh_w, 1);

            async->fh_r      = newSVsv (fh_r);
            async->fh_w      = newSVsv (fh_w);
            async->ep.fd [0] = fd_r;
            async->ep.fd [1] = fd_w;
            async->ep.len    = 1;
            async->fd_enable = 1;
          }

        async->value     = SvROK (pvalue)
                           ? SvREFCNT_inc_NN (SvRV (pvalue))
                           : NEWSV (0, 0);

        sv_setiv (async->value, 0);
        SvIOK_only (async->value); /* just to be sure */
        SvREADONLY_on (async->value);

        async->valuep    = &(SvIVX (async->value));

        async->autodrain = 1;
        async->cb        = cv;
        async->c_cb      = c_cb;
        async->c_arg     = c_arg;
        async->signum    = SvOK (signl) ? s_signum_croak (signl) : 0;

        if (async->signum)
          {
            if (async->signum < 0)
              croak ("Async::Interrupt::new got passed illegal signal name or number: %s", SvPV_nolen (signl));

            sig_async [async->signum] = async;
            setsig (async->signum, async_sigsend);
          }
}
#line 489 "Interrupt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Async__Interrupt_signal_hysteresis); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Async__Interrupt_signal_hysteresis)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "async, enable");
    {
	async_t *	async = SvASYNC (ST(0))
;
	int	enable = (int)SvIV(ST(1))
;
#line 328 "Interrupt.xs"
        async->hysteresis = enable;
#line 509 "Interrupt.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Async__Interrupt_signal_func); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Async__Interrupt_signal_func)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "async");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	async_t *	async = SvASYNC (ST(0))
;
#line 333 "Interrupt.xs"
        EXTEND (SP, 2);
        PUSHs (sv_2mortal (newSViv (PTR2IV (async_signal))));
        PUSHs (sv_2mortal (newSViv (PTR2IV (async))));
#line 530 "Interrupt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Async__Interrupt_scope_block_func); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Async__Interrupt_scope_block_func)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	self = ST(0)
;
#line 340 "Interrupt.xs"
        EXTEND (SP, 2);
        PUSHs (sv_2mortal (newSViv (PTR2IV (scope_block))));
        PUSHs (sv_2mortal (newSViv (PTR2IV (SvRV (self)))));
#line 552 "Interrupt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Async__Interrupt_c_var); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Async__Interrupt_c_var)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "async");
    {
	IV	RETVAL;
	dXSTARG;
	async_t *	async = SvASYNC (ST(0))
;
#line 347 "Interrupt.xs"
        RETVAL = PTR2IV (async->valuep);
#line 572 "Interrupt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Async__Interrupt_handle); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Async__Interrupt_handle)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "async");
    {
	async_t *	async = SvASYNC (ST(0))
;
#line 354 "Interrupt.xs"
        handle_async (async);
#line 590 "Interrupt.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Async__Interrupt_signal); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Async__Interrupt_signal)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "async, value= 1");
    {
	async_t *	async = SvASYNC (ST(0))
;
	int	value;

	if (items < 2)
	    value = 1;
	else {
	    value = (int)SvIV(ST(1))
;
	}
#line 359 "Interrupt.xs"
        async_signal (async, value);
#line 615 "Interrupt.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Async__Interrupt_block); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Async__Interrupt_block)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "async");
    {
	async_t *	async = SvASYNC (ST(0))
;
#line 364 "Interrupt.xs"
        block (async);
#line 632 "Interrupt.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Async__Interrupt_unblock); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Async__Interrupt_unblock)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "async");
    {
	async_t *	async = SvASYNC (ST(0))
;
#line 369 "Interrupt.xs"
        unblock (async);
#line 649 "Interrupt.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Async__Interrupt_scope_block); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Async__Interrupt_scope_block)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
#line 374 "Interrupt.xs"
        scope_block (SvRV (self));
#line 666 "Interrupt.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Async__Interrupt_pipe_enable); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Async__Interrupt_pipe_enable)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "async");
    {
	async_t *	async = SvASYNC (ST(0))
;
#line 382 "Interrupt.xs"
        async->fd_enable = ix;
#line 684 "Interrupt.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Async__Interrupt_pipe_fileno); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Async__Interrupt_pipe_fileno)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "async");
    {
	int	RETVAL;
	dXSTARG;
	async_t *	async = SvASYNC (ST(0))
;
#line 387 "Interrupt.xs"
        if (!async->ep.len)
          {
            int res;

            /*block (async);*//*TODO*/
            res = s_epipe_new (&async->ep);
            async->fd_enable = 1;
            /*unblock (async);*//*TODO*/

            if (res < 0)
              croak ("Async::Interrupt: unable to initialize event pipe");
          }

	RETVAL = async->ep.fd [0];
#line 716 "Interrupt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Async__Interrupt_pipe_autodrain); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Async__Interrupt_pipe_autodrain)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "async, enable= -1");
    {
	int	RETVAL;
	dXSTARG;
	async_t *	async = SvASYNC (ST(0))
;
	int	enable;

	if (items < 2)
	    enable = -1;
	else {
	    enable = (int)SvIV(ST(1))
;
	}
#line 407 "Interrupt.xs"
	RETVAL = async->autodrain;
        if (enable >= 0)
          async->autodrain = enable;
#line 746 "Interrupt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Async__Interrupt_pipe_drain); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Async__Interrupt_pipe_drain)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "async");
    {
	async_t *	async = SvASYNC (ST(0))
;
#line 416 "Interrupt.xs"
        if (async->ep.len)
          s_epipe_drain (&async->ep);
#line 765 "Interrupt.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Async__Interrupt_post_fork); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Async__Interrupt_post_fork)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "async");
    {
	async_t *	async = SvASYNC (ST(0))
;
#line 422 "Interrupt.xs"
        if (async->ep.len)
          {
	    int res;

            /*block (async);*//*TODO*/
            res = s_epipe_renew (&async->ep);
            /*unblock (async);*//*TODO*/

            if (res < 0)
              croak ("Async::Interrupt: unable to initialize event pipe after fork");
          }
#line 792 "Interrupt.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Async__Interrupt_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Async__Interrupt_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
#line 437 "Interrupt.xs"
{
	int i;
	SV *async_sv = SvRV (self);
	async_t *async = SvASYNC_nrv (async_sv);

        for (i = AvFILLp (asyncs); i >= 0; --i)
          if (AvARRAY (asyncs)[i] == async_sv)
            {
              AvARRAY (asyncs)[i] = AvARRAY (asyncs)[AvFILLp (asyncs)];
              av_pop (asyncs);
              goto found;
            }

        if (!PL_dirty)
          warn ("Async::Interrupt::DESTROY could not find async object in list of asyncs, please report");

	found:

        if (async->signum)
          setsig (async->signum, SIG_DFL);

        if (!async->fh_r && async->ep.len)
          s_epipe_destroy (&async->ep);

        SvREFCNT_dec (async->fh_r);
        SvREFCNT_dec (async->fh_w);
        SvREFCNT_dec (async->cb);
        SvREFCNT_dec (async->value);

        Safefree (async);
}
#line 839 "Interrupt.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Async__Interrupt_sig2num); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Async__Interrupt_sig2num)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "signame_or_number");
    {
	SV *	RETVAL;
	SV *	signame_or_number = ST(0)
;
#line 476 "Interrupt.xs"
{
  	int signum = s_signum (signame_or_number);

        if (signum < 0)
          RETVAL = &PL_sv_undef;
        else if (ix)
          RETVAL = newSVpv (PL_sig_name [signum], 0);
        else
          RETVAL = newSViv (signum);
}
#line 867 "Interrupt.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Async__Interrupt__EventPipe_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Async__Interrupt__EventPipe_new)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "klass");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	const char *	klass = (const char *)SvPV_nolen(ST(0))
;
#line 494 "Interrupt.xs"
{
	s_epipe *epp;

        Newz (0, epp, 1, s_epipe);
        XPUSHs (sv_setref_iv (sv_newmortal (), klass, PTR2IV (epp)));

        if (s_epipe_new (epp) < 0)
          croak ("Async::Interrupt::EventPipe: unable to create new event pipe");
}
#line 896 "Interrupt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Async__Interrupt__EventPipe_filenos); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Async__Interrupt__EventPipe_filenos)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "epp");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	s_epipe *	epp = INT2PTR (s_epipe *, SvIVX (SvRV (ST(0))))
;
#line 507 "Interrupt.xs"
        EXTEND (SP, 2);
        PUSHs (sv_2mortal (newSViv (epp->fd [0])));
        PUSHs (sv_2mortal (newSViv (epp->fd [1])));
#line 918 "Interrupt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Async__Interrupt__EventPipe_fileno); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Async__Interrupt__EventPipe_fileno)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "epp");
    {
	int	RETVAL;
	dXSTARG;
	s_epipe *	epp = INT2PTR (s_epipe *, SvIVX (SvRV (ST(0))))
;
#line 518 "Interrupt.xs"
        RETVAL = epp->fd [ix];
#line 939 "Interrupt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Async__Interrupt__EventPipe_type); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Async__Interrupt__EventPipe_type)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "epp");
    {
	int	RETVAL;
	dXSTARG;
	s_epipe *	epp = INT2PTR (s_epipe *, SvIVX (SvRV (ST(0))))
;
#line 525 "Interrupt.xs"
        RETVAL = epp->len;
#line 959 "Interrupt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Async__Interrupt__EventPipe_signal); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Async__Interrupt__EventPipe_signal)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "epp");
    {
	s_epipe *	epp = INT2PTR (s_epipe *, SvIVX (SvRV (ST(0))))
;

	s_epipe_signal(epp);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Async__Interrupt__EventPipe_drain); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Async__Interrupt__EventPipe_drain)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "epp");
    {
	s_epipe *	epp = INT2PTR (s_epipe *, SvIVX (SvRV (ST(0))))
;

	s_epipe_drain(epp);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Async__Interrupt__EventPipe_signal_func); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Async__Interrupt__EventPipe_signal_func)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "epp");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	s_epipe *	epp = INT2PTR (s_epipe *, SvIVX (SvRV (ST(0))))
;
#line 540 "Interrupt.xs"
        EXTEND (SP, 2);
        PUSHs (sv_2mortal (newSViv (PTR2IV (ix ? s_epipe_drain : s_epipe_signal))));
        PUSHs (sv_2mortal (newSViv (PTR2IV (epp))));
#line 1014 "Interrupt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Async__Interrupt__EventPipe_wait); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Async__Interrupt__EventPipe_wait)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "epp");
    {
	s_epipe *	epp = INT2PTR (s_epipe *, SvIVX (SvRV (ST(0))))
;

	s_epipe_wait(epp);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Async__Interrupt__EventPipe_renew); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Async__Interrupt__EventPipe_renew)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "epp");
    {
	s_epipe *	epp = INT2PTR (s_epipe *, SvIVX (SvRV (ST(0))))
;

	s_epipe_renew(epp);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Async__Interrupt__EventPipe_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Async__Interrupt__EventPipe_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "epp");
    {
	s_epipe *	epp = INT2PTR (s_epipe *, SvIVX (SvRV (ST(0))))
;
#line 553 "Interrupt.xs"
        s_epipe_destroy (epp);
#line 1064 "Interrupt.c"
    }
    XSRETURN_EMPTY;
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Async__Interrupt); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Async__Interrupt)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Async::Interrupt::_alloc", XS_Async__Interrupt__alloc);
        newXS_deffile("Async::Interrupt::signal_hysteresis", XS_Async__Interrupt_signal_hysteresis);
        newXS_deffile("Async::Interrupt::signal_func", XS_Async__Interrupt_signal_func);
        newXS_deffile("Async::Interrupt::scope_block_func", XS_Async__Interrupt_scope_block_func);
        newXS_deffile("Async::Interrupt::c_var", XS_Async__Interrupt_c_var);
        newXS_deffile("Async::Interrupt::handle", XS_Async__Interrupt_handle);
        newXS_deffile("Async::Interrupt::signal", XS_Async__Interrupt_signal);
        newXS_deffile("Async::Interrupt::block", XS_Async__Interrupt_block);
        newXS_deffile("Async::Interrupt::unblock", XS_Async__Interrupt_unblock);
        newXS_deffile("Async::Interrupt::scope_block", XS_Async__Interrupt_scope_block);
        cv = newXS_deffile("Async::Interrupt::pipe_disable", XS_Async__Interrupt_pipe_enable);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("Async::Interrupt::pipe_enable", XS_Async__Interrupt_pipe_enable);
        XSANY.any_i32 = 1;
        newXS_deffile("Async::Interrupt::pipe_fileno", XS_Async__Interrupt_pipe_fileno);
        newXS_deffile("Async::Interrupt::pipe_autodrain", XS_Async__Interrupt_pipe_autodrain);
        newXS_deffile("Async::Interrupt::pipe_drain", XS_Async__Interrupt_pipe_drain);
        newXS_deffile("Async::Interrupt::post_fork", XS_Async__Interrupt_post_fork);
        newXS_deffile("Async::Interrupt::DESTROY", XS_Async__Interrupt_DESTROY);
        cv = newXSproto_portable("Async::Interrupt::sig2name", XS_Async__Interrupt_sig2num, file, "$");
        XSANY.any_i32 = 1;
        cv = newXSproto_portable("Async::Interrupt::sig2num", XS_Async__Interrupt_sig2num, file, "$");
        XSANY.any_i32 = 0;
        newXS_deffile("Async::Interrupt::EventPipe::new", XS_Async__Interrupt__EventPipe_new);
        newXS_deffile("Async::Interrupt::EventPipe::filenos", XS_Async__Interrupt__EventPipe_filenos);
        cv = newXS_deffile("Async::Interrupt::EventPipe::fileno", XS_Async__Interrupt__EventPipe_fileno);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("Async::Interrupt::EventPipe::fileno_r", XS_Async__Interrupt__EventPipe_fileno);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("Async::Interrupt::EventPipe::fileno_w", XS_Async__Interrupt__EventPipe_fileno);
        XSANY.any_i32 = 1;
        newXS_deffile("Async::Interrupt::EventPipe::type", XS_Async__Interrupt__EventPipe_type);
        newXS_deffile("Async::Interrupt::EventPipe::signal", XS_Async__Interrupt__EventPipe_signal);
        newXS_deffile("Async::Interrupt::EventPipe::drain", XS_Async__Interrupt__EventPipe_drain);
        cv = newXS_deffile("Async::Interrupt::EventPipe::drain_func", XS_Async__Interrupt__EventPipe_signal_func);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("Async::Interrupt::EventPipe::signal_func", XS_Async__Interrupt__EventPipe_signal_func);
        XSANY.any_i32 = 0;
        newXS_deffile("Async::Interrupt::EventPipe::wait", XS_Async__Interrupt__EventPipe_wait);
        newXS_deffile("Async::Interrupt::EventPipe::renew", XS_Async__Interrupt__EventPipe_renew);
        newXS_deffile("Async::Interrupt::EventPipe::DESTROY", XS_Async__Interrupt__EventPipe_DESTROY);

    /* Initialisation Section */

#line 263 "Interrupt.xs"
	old_sighandler = PL_sighandlerp;
        PL_sighandlerp = async_sighandler;
        sig_pending = &PL_sig_pending;
        psig_pend   = PL_psig_pend;
        asyncs      = newAV ();
        CvNODEBUG_on (get_cv ("Async::Interrupt::scope_block", 0)); /* otherwise calling scope can be the debugger */

#line 1149 "Interrupt.c"

    /* End of Initialisation Section */

#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

